//*****************************************************************
// 
//  JAVA Source for com.idautomation.linear; 2010
//  
//	 Copyright IDAutomation.com, Inc. All rights reserved.
//	Redistribution and use of this code in source and/or binary 
//	forms, with or without modification, are permitted provided 
//	that: (1) all copies of the source code retain the above 
//	unmodified copyright notice and this entire unmodified 
//	section of text, (2) You or Your organization owns a valid 
//	Developer License to this product from IDAutomation.com 
//	and, (3) when any portion of this code is bundled in any 
//	form with an application, a valid notice must be provided 
//	within the user documentation, start-up screen or in the 
//	help-about section of the application that specifies 
//	IDAutomation.com as the provider of the Software bundled 
//	with the application.
//*****************************************************************

package com.idautomation.linear;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.awt.Graphics2D.*;
import java.awt.*;
/** This is the Linear servlet that creates a barcode from the BarCode class. */
public class IDAutomationServlet extends HttpServlet {
	/**
	* Handle the HTTP POST method by sending an e-mail
	*/
	private boolean debug=true;
	public void init() throws ServletException  {	}
	// MODIFY THIS METHOD TO RETRIEVE DATA TO ENCODE, CREATE THE BARCODE AND SET THE PARAMETERS
	private BarCode getChart (HttpServletRequest request) 
	{
		BarCode cb=new BarCode();
		if (request!=null) 
		{
			// Remark these parameters out if you do not need them. We also recommend fixing parameters so they
			// do not need to be defined in the barcode IMG string. For example, instead of 
			// if (request.getParameter("BAR_HEIGHT")!=null) cb.barHeightCM=new Double(request.getParameter("BAR_HEIGHT")).doubleValue();
			// use
			// cb.barHeightCM=2;
			// if you always use a bar height of 2.
			String st = null;
			if (request.getParameter("CODE_TYPE")!=null)
			{
				st = (request.getParameter("CODE_TYPE"));
				if (st.compareTo("CODE39")==0)			cb.barType=0;
				if (st.compareTo("CODE39EXT")==0)		cb.barType=1;
				if (st.compareTo("INTERLEAVED25")==0)           cb.barType=2;
				if (st.compareTo("CODE11")==0)			cb.barType=3;
				if (st.compareTo("CODABAR")==0)			cb.barType=4;
				if (st.compareTo("MSI")==0)			cb.barType=5;
				if (st.compareTo("UPCA")==0)			cb.barType=6;
				if (st.compareTo("IND25")==0)			cb.barType=7;
				if (st.compareTo("MAT25")==0)			cb.barType=8;
				if (st.compareTo("CODE93")==0)			cb.barType=9;
				if (st.compareTo("EAN13")==0)			cb.barType=10;
				if (st.compareTo("EAN8")==0)			cb.barType=11;
				if (st.compareTo("UPCE")==0)			cb.barType=12;
				if (st.compareTo("CODE128")==0)			cb.barType=13;
				if (st.compareTo("CODE93EXT")==0)		cb.barType=14;
				if (st.compareTo("POSTNET")==0)			cb.barType=15;
				if (st.compareTo("PLANET")==0)			cb.barType=16;
				if (st.compareTo("UCC128")==0)			cb.barType=17;
				if (st.compareTo("ONECODE")==0)			cb.barType=18;
                                if (st.compareTo("INTELLIGENTMAIL")==0)		cb.barType=18;
			}
                        if (request.getParameter("S")!=null)
                            {
				st = (request.getParameter("S"));
				if (st.toUpperCase().compareTo("CODE39") == 0 || st.compareTo("0")==0)			
                                    cb.barType=0;
				if (st.toUpperCase().compareTo("CODE39EXT") == 0 || st.compareTo("1")==0)		
                                    cb.barType=1;
				if (st.toUpperCase().compareTo("INTERLEAVED25") == 0 || st.compareTo("2")==0)           
                                    cb.barType=2;
				if (st.toUpperCase().compareTo("CODE11") == 0 || st.compareTo("3")==0)			
                                    cb.barType=3;
				if (st.toUpperCase().compareTo("CODABAR") == 0 || st.compareTo("4")==0)			
                                    cb.barType=4;
				if (st.toUpperCase().compareTo("MSI") == 0 || st.compareTo("5")==0)			
                                    cb.barType=5;
				if (st.toUpperCase().compareTo("UPCA") == 0 || st.compareTo("6")==0)			
                                    cb.barType=6;
				if (st.toUpperCase().compareTo("IND25") == 0 || st.compareTo("7")==0)			
                                    cb.barType=7;
				if (st.toUpperCase().compareTo("MAT25") == 0 || st.compareTo("8")==0)			
                                    cb.barType=8;
				if (st.toUpperCase().compareTo("CODE93") == 0 || st.compareTo("9")==0)			
                                    cb.barType=9;
				if (st.toUpperCase().compareTo("EAN13") == 0 || st.compareTo("10")==0)			
                                    cb.barType=10;
				if (st.toUpperCase().compareTo("EAN8") == 0 || st.compareTo("11")==0)			
                                    cb.barType=11;
				if (st.toUpperCase().compareTo("UPCE") == 0 || st.compareTo("12")==0)			
                                    cb.barType=12;
				if (st.toUpperCase().compareTo("CODE128") == 0 || st.compareTo("13")==0)			
                                    cb.barType=13;
				if (st.toUpperCase().compareTo("CODE93EXT") == 0 || st.compareTo("14")==0)		
                                    cb.barType=14;
				if (st.toUpperCase().compareTo("POSTNET") == 0 || st.compareTo("15")==0)			
                                    cb.barType=15;
				if (st.toUpperCase().compareTo("PLANET") == 0 || st.compareTo("16")==0)			
                                    cb.barType=16;
				if (st.toUpperCase().compareTo("UCC128") == 0 || st.compareTo("17")==0)			
                                    cb.barType=17;
				if (st.toUpperCase().compareTo("ONECODE") == 0 || st.toUpperCase().compareTo("INTELLIGENTMAIL") == 0 || st.compareTo("18")==0)
                                    cb.barType=18;				
			}
			if (request.getParameter("ROTATE")!=null) cb.rotate=new Integer(request.getParameter("ROTATE")).intValue();
                        if (request.getParameter("O")!=null) cb.rotate=new Integer(request.getParameter("O")).intValue();
			if (request.getParameter("BAR_HEIGHT")!=null) cb.barHeightCM=new Double(request.getParameter("BAR_HEIGHT")).doubleValue();
                        if (request.getParameter("BH")!=null) cb.barHeightCM=new Double(request.getParameter("BH")).doubleValue();
			if (request.getParameter("X")!=null) cb.X=new Double(request.getParameter("X")).doubleValue();
			if (request.getParameter("N")!=null) cb.N=new Double(request.getParameter("N")).doubleValue();
			if (request.getParameter("LEFT_MARGIN")!=null) cb.leftMarginCM=new Double(request.getParameter("LEFT_MARGIN")).doubleValue();
                        if (request.getParameter("LM")!=null) cb.leftMarginCM=new Double(request.getParameter("LM")).doubleValue();
			if (request.getParameter("TOP_MARGIN")!=null) cb.topMarginCM=new Double(request.getParameter("TOP_MARGIN")).doubleValue();
			if (request.getParameter("TM")!=null) cb.topMarginCM=new Double(request.getParameter("TM")).doubleValue();
			if (request.getParameter("UPCE_SYSTEM")!=null) cb.UPCESystem=request.getParameter("UPCE_SYSTEM").charAt(0);
                        if (request.getParameter("UES")!=null) cb.UPCESystem=request.getParameter("UES").charAt(0);
			if (request.getParameter("TEXT_FONT")!=null) cb.textFont=convertFont(request.getParameter("TEXT_FONT"));
                        if (request.getParameter("F")!=null) cb.textFont=new Font(request.getParameter("F"),Font.PLAIN,cb.textFont.getSize());
                        if (request.getParameter("FS")!=null) cb.textFont=cb.textFont.deriveFont(new Float(request.getParameter("FS")).floatValue());
			if (request.getParameter("FONT_COLOR")!=null) cb.fontColor=convertColor(request.getParameter("FONT_COLOR"));
                        if (request.getParameter("FC")!=null) cb.fontColor=convertColor(request.getParameter("FC"));
			if (request.getParameter("BAR_COLOR")!=null) cb.barColor=convertColor(request.getParameter("BAR_COLOR"));
                        if (request.getParameter("BC")!=null) cb.barColor=convertColor(request.getParameter("BC"));
			if (request.getParameter("BACK_COLOR")!=null) cb.backColor=convertColor(request.getParameter("BACK_COLOR"));
                        if (request.getParameter("BGC")!=null) cb.backColor=convertColor(request.getParameter("BGC"));
			if (request.getParameter("CHARACTER_GROUPING")!=null) cb.ValSpliceText=new Integer(request.getParameter("CHARACTER_GROUPING")).intValue();
                        if (request.getParameter("CG")!=null) cb.ValSpliceText=new Integer(request.getParameter("CG")).intValue();
                        if (request.getParameter("IR")!=null) cb.setPixelsPerCM(new Integer(request.getParameter("IR")).intValue());
                        
                        if (request.getParameter("SUPD")!=null) cb.supplement=request.getParameter("SD");
                        if (request.getParameter("SEP")!=null) cb.supSeparationCM=new Double(request.getParameter("SEP")).doubleValue();
                        if (request.getParameter("SUPH")!=null) cb.supHeight=new Double(request.getParameter("SUPH")).doubleValue();
                        if (request.getParameter("PNT")!=null) cb.postnetHeightTallBar=(int) (new Double(request.getParameter("PNT")).doubleValue());
                        if (request.getParameter("PNS")!=null) cb.postnetHeightShortBar=(int) (new Double(request.getParameter("PNS")).doubleValue());
                        if (request.getParameter("CBSTART")!=null) cb.CODABARStartChar=new String(request.getParameter("CBSTOP")).charAt(0);
                        if (request.getParameter("CBSTOP")!=null) cb.CODABARStopChar=new String(request.getParameter("CBSTOP")).charAt(0);

                        if (request.getParameter("SUP")!=null)
                        {
                            String SUPParam = request.getParameter("SUP");
                            cb.UPCEANSupplement2=false;
                            cb.UPCEANSupplement5=false;
                            if (SUPParam.compareTo("2")==0) cb.UPCEANSupplement2=true;
                            if (SUPParam.compareTo("5")==0) cb.UPCEANSupplement5=true;
                        }
                        //if (request.getParameter("PT")!=null) cb.processTilde=(request.getParameter("PT").compareTo("Y")==0);
                        if (request.getParameter("PT")!=null)
                        {
                            String STParameter = request.getParameter("PT");
                            if(STParameter.toUpperCase().compareTo("Y") == 0 || STParameter.toUpperCase().compareTo("YES") == 0 ||
                               STParameter.toUpperCase().compareTo("TRUE") == 0 || STParameter.toUpperCase().compareTo("T") == 0)
                                cb.processTilde = true;
                            else
                                cb.processTilde = false;
                        }
                        
                        if (request.getParameter("CHECK_CHARINTEXT")!=null) cb.checkCharacterInText=(request.getParameter("CHECK_CHARINTEXT").compareTo("Y")==0);
			if (request.getParameter("CT")!=null)
                        {
                            String STParameter = request.getParameter("CT");
                            if(STParameter.toUpperCase().compareTo("Y") == 0 || STParameter.toUpperCase().compareTo("YES") == 0 ||
                               STParameter.toUpperCase().compareTo("TRUE") == 0 || STParameter.toUpperCase().compareTo("T") == 0)
                                cb.checkCharacterInText = true;
                            else
                                cb.checkCharacterInText = false;
                        }
                        
                        if (request.getParameter("CHECK_CHAR")!=null) cb.checkCharacter=(request.getParameter("CHECK_CHAR").compareTo("Y")==0);
			if (request.getParameter("CC")!=null)
                        {
                            String STParameter = request.getParameter("CC");
                            if(STParameter.toUpperCase().compareTo("Y") == 0 || STParameter.toUpperCase().compareTo("YES") == 0 ||
                               STParameter.toUpperCase().compareTo("TRUE") == 0 || STParameter.toUpperCase().compareTo("T") == 0)
                                cb.showText = true;
                            else
                                cb.showText = false;
                        }
                        
                        if (request.getParameter("CODE128_SET")!=null) cb.Code128Set=request.getParameter("CODE128_SET").charAt(0);
                        //if (request.getParameter("CS")!=null) cb.Code128Set=request.getParameter("CS").charAt(0);
                        if (request.getParameter("CS")!=null) 
                        {
                            char csParam = request.getParameter("CS").charAt(0);
                            if(csParam >= '0' && csParam <= '3')
                            {
                                switch(csParam)
                                {
                                    case '0':
                                    {
                                        cb.setCode128Set(String.valueOf("AUTO"));
                                        break;
                                    }
                                    case '1':
                                    {
                                        cb.setCode128Set(String.valueOf("A"));
                                        break;
                                    }
                                    case '2':
                                    {
                                        cb.setCode128Set(String.valueOf("B"));
                                        break;
                                    }
                                    case '3':
                                    {
                                        cb.setCode128Set(String.valueOf("C"));
                                        break;
                                    }
                                }
                            }
                            else
                                cb.setCode128Set(String.valueOf(csParam));
                        }
                        
                        //if (request.getParameter("ST")!=null) cb.showText=(request.getParameter("ST").compareTo("Y")==0);
                        if (request.getParameter("ST")!=null)
                        {
                            String STParameter = request.getParameter("ST");
                            if(STParameter.toUpperCase().compareTo("Y") == 0 || STParameter.toUpperCase().compareTo("YES") == 0 ||
                               STParameter.toUpperCase().compareTo("TRUE") == 0 || STParameter.toUpperCase().compareTo("T") == 0)
                                cb.showText = true;
                            else
                                cb.showText = false;
                        }
                        
			if (request.getParameter("BARCODE")!=null) 
			{
				cb.code=request.getParameter("BARCODE"); 
			}
                        else if(request.getParameter("D")!=null)
                        {
                            cb.code=request.getParameter("D");
                        }
			else  
			{
				cb.code="01234567094987654321";
			}
			if (request.getParameter("WHITE_BAR_INCREASE")!=null) cb.WhiteBarIncrease=new Float(request.getParameter("WHITE_BAR_INCREASE")).floatValue();
                        if (request.getParameter("WI")!=null) cb.WhiteBarIncrease=new Float(request.getParameter("WI")).floatValue();
			if (request.getParameter("BEARER_BAR_HORIZONTAL")!=null) cb.fBearerBarHori=new Float(request.getParameter("BEARER_BAR_HORIZONTAL")).floatValue();
                        if (request.getParameter("BBH")!=null) cb.fBearerBarHori=new Float(request.getParameter("BBH")).floatValue();
			if (request.getParameter("BEARER_BAR_VERTICAL")!=null) cb.fBearerBarVert=new Float(request.getParameter("BEARER_BAR_VERTICAL")).floatValue();
                        if (request.getParameter("BBV")!=null) cb.fBearerBarVert=new Float(request.getParameter("BBV")).floatValue();
			if (request.getParameter("TEXT_MARGIN")!=null) cb.textMarginCM=new Float(request.getParameter("TEXT_MARGIN")).floatValue();
                        if (request.getParameter("EM")!=null) cb.textMarginCM=new Float(request.getParameter("EM")).floatValue();

		}
		else  {
			cb.code="No Data";
		}
		return cb;
	}

	public java.awt.Font convertFont(String f) 
	{
		String[] items=convertList(f);
		if (items==null) return null;
		if (items.length<3) return null;
		int s=java.awt.Font.PLAIN;
		if (items[1].compareTo("BOLD")==0) s=java.awt.Font.BOLD;
		if (items[1].compareTo("ITALIC")==0) s=java.awt.Font.ITALIC;
		try 
		{
			return new java.awt.Font(items[0],s,new Integer(items[2]).intValue());
		}
		catch (Exception e) {return null;}
	}
	private String[] convertList(String items)
	{
		String[] itema=new String[500];
		int itemCount=0;
		// count number of items
		int p=items.indexOf("|");
		while (p>=0) 
		{
			itema[itemCount++]=items.substring(0,p);
			items=items.substring(p+1,items.length());
			p=items.indexOf("|");
		}
		if (items.compareTo("")!=0) itema[itemCount++]=items;
		if (itemCount==0) return null;
		String[] result=new String[itemCount];
		for (int i=0;i<itemCount;i++) result[i]=itema[i];
		return result;
	}
	public java.awt.Color convertColor(String c) 
        {
            if (c.toUpperCase().compareTo("NULL")==0) return null;
            if (c.toUpperCase().compareTo("RED")==0) return java.awt.Color.red;
            if (c.toUpperCase().compareTo("BLACK")==0) return java.awt.Color.black;
            if (c.toUpperCase().compareTo("BLUE")==0) return java.awt.Color.blue;
            if (c.toUpperCase().compareTo("CYAN")==0) return java.awt.Color.cyan;
            if (c.toUpperCase().compareTo("DARKGRAY")==0) return java.awt.Color.darkGray;
            if (c.toUpperCase().compareTo("GRAY")==0) return java.awt.Color.gray;
            if (c.toUpperCase().compareTo("GREEN")==0) return java.awt.Color.green;
            if (c.toUpperCase().compareTo("LIGHTGRAY")==0) return java.awt.Color.lightGray;
            if (c.toUpperCase().compareTo("MAGENTA")==0) return java.awt.Color.magenta;
            if (c.toUpperCase().compareTo("ORANGE")==0) return java.awt.Color.orange;
            if (c.toUpperCase().compareTo("PINK")==0) return java.awt.Color.pink;
            if (c.toUpperCase().compareTo("WHITE")==0) return java.awt.Color.white;
            if (c.toUpperCase().compareTo("YELLOW")==0) return java.awt.Color.yellow;
            try 
            {
                return java.awt.Color.decode(c);
            } 
            catch (Exception e) 
            {
                return java.awt.Color.black;
            }
        }


	// Handle the request
	// 1. create barcode
	// 2. draw barcode in a Buffered Image
	// 3. encode image as GIF or JPEG and send it to the browser
	public void doGet (HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException 
	{
		PrintWriter	out;
		ServletOutputStream outb;
		//default encoding type
		String encode="gif";
		if (request!=null) 
		{
			if (request.getParameter("FORMAT")!=null)  encode=request.getParameter("FORMAT").toLowerCase();
                        if (request.getParameter("I")!=null)  encode=request.getParameter("I").toLowerCase();
			if (encode.compareTo("gif")!=0) encode="jpeg";
		}
		response.setContentType("image/"+encode);
		outb=response.getOutputStream();
		// avoid caching in browser
		response.setHeader ("Pragma", "no-cache");
		response.setHeader ("Cache-Control", "no-cache");
		response.setDateHeader ("Expires",0);
		try 
		{ 
			// find sizes
			int w=10;
			int h=10;
			// get the BarCode
			BarCode cb=getChart(request);
			if ((request!=null) && (request.getParameter("WIDTH")!=null) && (request.getParameter("HEIGHT")!=null)) 
			{
					w=new Integer(request.getParameter("WIDTH")).intValue();
					h=new Integer(request.getParameter("HEIGHT")).intValue();
			}
                        else if ((request!=null) && (request.getParameter("W")!=null) && (request.getParameter("H")!=null)) 
			{
					w=new Integer(request.getParameter("W")).intValue();
					h=new Integer(request.getParameter("H")).intValue();
			}
			else 
			{
					//a temp image must be created to find the preferred size
					cb.autoSize=true;
					cb.setSize(600,90);
					java.awt.image.BufferedImage imageTemp = new java.awt.image.BufferedImage( cb.getSize().width,cb.getSize().height,java.awt.image.BufferedImage.TYPE_BYTE_INDEXED );
					java.awt.Graphics imgTempGraphics = imageTemp.createGraphics();
					cb.paint(imgTempGraphics);
					cb.invalidate();
					w=cb.getSize().width;
					h=cb.getSize().height;
					imgTempGraphics.dispose();
			}
			java.awt.image.BufferedImage BarImage=new java.awt.image.BufferedImage(w,h,java.awt.image.BufferedImage.TYPE_INT_RGB);
			java.awt.Graphics2D BarGraphics=BarImage.createGraphics();
			if (debug) System.out.println("Size: "+w+" "+h);
			cb.setSize(w,h);
			cb.paint(BarGraphics);
			if (encode.compareToIgnoreCase("gif")==0) 
			{
				// encode buffered image to a gif
				com.idautomation.linear.encoder.GifEncoder encoder = new com.idautomation.linear.encoder.GifEncoder(BarImage  ,outb);
				encoder.encode();
			}
			else
			{
				// create JPEG image
				com.sun.image.codec.jpeg.JPEGImageEncoder encoder = com.sun.image.codec.jpeg.JPEGCodec.createJPEGEncoder(outb );
				//increase the JPEG quality to 100%
      			com.sun.image.codec.jpeg.JPEGEncodeParam param = encoder.getDefaultJPEGEncodeParam( BarImage); 
				param.setQuality(1.0F,true);
				encoder.setJPEGEncodeParam(param);
				encoder.encode( BarImage,param  );
			}
		} 
		catch (Exception e) { e.printStackTrace();}
	}

	public void doPost (HttpServletRequest request,
						HttpServletResponse response)
						throws ServletException
	{
	try {
			doGet(request,response);
		} 
	catch (Exception e) { e.printStackTrace();}
		}
	}
