//*****************************************************************
// 
//  JAVA Source for com.idautomation.pdf417; 2010
//  
//	 Copyright IDAutomation.com, Inc. All rights reserved.
//	Redistribution and use of this code in source and/or binary 
//	forms, with or without modification, are permitted provided 
//	that: (1) all copies of the source code retain the above 
//	unmodified copyright notice and this entire unmodified 
//	section of text, (2) You or Your organization owns a valid 
//	Developer License to this product from IDAutomation.com 
//	and, (3) when any portion of this code is bundled in any 
//	form with an application, a valid notice must be provided 
//	within the user documentation, start-up screen or in the 
//	help-about section of the application that specifies 
//	IDAutomation.com as the provider of the Software bundled 
//	with the application.
//*****************************************************************


package com.idautomation.pdf417;

import java.awt.*;
import java.applet.*;

/** This is the PDF417 applet that creates a barcode from the PDF417 class. */

public class PDF417Applet extends Applet
{

    // ** updated for servlet operation 5/31/2001
            public PDF417 BC=null;
    public boolean isStandalone=false;
    // ** end of update

    public PDF417Applet() {
            this.setLayout(new java.awt.BorderLayout());
    }

    public void start() {
            BC.paint(this.getGraphics());
            BC.autoSize=false;
    }

    public void refresh() {
            BC.paint(BC.getGraphics());
            this.paintAll(this.getGraphics());
    }

    public void init() {
        // create bar code PDF417
        if (BC==null) BC=new PDF417();	

        this.add("Center",BC);		

        initParam("N");
        initParam("X");
        initParam("I");
        initParam("H");
        initParam("BAR_COLOR");
        initParam("BACK_COLOR");
        initParam("LEFT_MARGIN");
        initParam("TOP_MARGIN");
        initParam("BARCODE");
        initParam("ROTATE");
        initParam("BC");
        initParam("BGC");
        initParam("LM");
        initParam("TM");
        initParam("D");
        initParam("O");
        // pdf417 specific
        initParam("PT");
        initParam("XYR");
        initParam("TRN");
        initParam("MODE");
        initParam("ROWS");
        initParam("COL");
        initParam("MAE");
        initParam("MAF");
        initParam("MAS");
        initParam("MAL");
        initParam("ECL");

    }

    private void initParam(String p) 
    {
        String v=getStringParam(p,"");
        if (v.length()==0) return;
        setParameter(p,v);
    }

    public void setParameter(String p,String v) 
    {

        if (v==null) return;

        if (p.compareTo("N")==0) BC.N=new Double(v).doubleValue();

        if (p.compareTo("ROTATE")==0) BC.rotate=(int) (new Double(v).doubleValue());

        if (p.compareTo("X")==0) BC.setXDimensionCM((double) (new Double(v).doubleValue()));

        if (p.compareTo("XYR")==0) BC.setXtoYRatio((double) (new Double(v).doubleValue()));

        if (p.compareTo("TRN")==0) BC.truncated=(v.compareTo("Y")==0);

        if (p.compareTo("I")==0) BC.I=new Double(v).doubleValue();

        if (p.compareTo("LEFT_MARGIN")==0) BC.leftMarginCM=new Double(v).doubleValue();

        if (p.compareTo("TOP_MARGIN")==0) BC.topMarginCM=new Double(v).doubleValue();

        if (p.compareTo("BAR_COLOR")==0) BC.barColor=convertColor(v);

        if (p.compareTo("BACK_COLOR")==0) BC.backColor=convertColor(v);

        if (p.compareTo("LM")==0) BC.leftMarginCM=new Double(v).doubleValue();

        if (p.compareTo("TM")==0) BC.topMarginCM=new Double(v).doubleValue();

        if (p.compareTo("BC")==0) BC.barColor=convertColor(v);

        if (p.compareTo("BGC")==0) BC.backColor=convertColor(v);

        if (p.compareTo("O")==0) BC.rotate=(int) (new Double(v).doubleValue());

        if (p.compareTo("H")==0) BC.H=new Double(v).doubleValue();

//		if (p.compareTo("BARCODE")==0) BC.code=v;

        if (p.compareTo("ROWS")==0) BC.PDFRows=new Integer(v).intValue();
        if (p.compareTo("COL")==0) BC.PDFColumns=new Integer(v).intValue();
        if (p.compareTo("ECL")==0) BC.PDFECLevel=new Integer(v).intValue();
        if (p.compareTo("IR")==0) BC.setPixelsPerCM(new Integer(v).intValue());
        if (p.compareTo("PT")==0)
        {
            String PTParameter = v;
            if(PTParameter.toUpperCase().compareTo("Y") == 0 || PTParameter.toUpperCase().compareTo("YES") == 0 ||
               PTParameter.toUpperCase().compareTo("TRUE") == 0 || PTParameter.toUpperCase().compareTo("T") == 0)
                BC.processTilde = true;
            else
                BC.processTilde = false;

        }
        if (p.compareTo("MAF")==0) BC.MacroPDFFileID=new Integer(v).intValue();
        if (p.compareTo("MAS")==0) BC.MacroPDFSegmentIndex=new Integer(v).intValue();
        if (p.compareTo("MAE")==0)
        {
            String MAEParameter = v;
            if(MAEParameter.toUpperCase().compareTo("Y") == 0 || MAEParameter.toUpperCase().compareTo("YES") == 0 ||
               MAEParameter.toUpperCase().compareTo("TRUE") == 0 || MAEParameter.toUpperCase().compareTo("T") == 0)
                BC.MacroPDFEnable = true;
            else
                BC.MacroPDFEnable = false;
        }
        if (p.compareTo("MAL")==0)
        {
            String MALParameter = v;
            if(MALParameter.toUpperCase().compareTo("Y") == 0 || MALParameter.toUpperCase().compareTo("YES") == 0 ||
               MALParameter.toUpperCase().compareTo("TRUE") == 0 || MALParameter.toUpperCase().compareTo("T") == 0)
                BC.MacroPDFLastSegment = true;
            else
                BC.MacroPDFLastSegment = false;
        }

        if (p.compareTo("MODE")==0) 
        {
            if (v.compareTo("BINARY")==0 || v.compareTo("0")==0) BC.PDFMode=BC.PDF_BINARY;
            if (v.compareTo("TEXT")==0 || v.compareTo("1")==0) BC.PDFMode=BC.PDF_TEXT;
            if (v.compareTo("NUMERIC")==0 || v.compareTo("2")==0) BC.PDFMode=BC.PDF_NUMERIC;
        }
        if (p.compareTo("BARCODE")==0) BC.setDataToEncode(v);
        if (p.compareTo("D")==0) BC.setDataToEncode(v);
    }

    // function to convert a String parameter to a color
    public java.awt.Color convertColor(String c) 
    {
        if (c.toUpperCase().compareTo("NULL")==0) return null;
        if (c.toUpperCase().compareTo("RED")==0) return java.awt.Color.red;
        if (c.toUpperCase().compareTo("BLACK")==0) return java.awt.Color.black;
        if (c.toUpperCase().compareTo("BLUE")==0) return java.awt.Color.blue;
        if (c.toUpperCase().compareTo("CYAN")==0) return java.awt.Color.cyan;
        if (c.toUpperCase().compareTo("DARKGRAY")==0) return java.awt.Color.darkGray;
        if (c.toUpperCase().compareTo("GRAY")==0) return java.awt.Color.gray;
        if (c.toUpperCase().compareTo("GREEN")==0) return java.awt.Color.green;
        if (c.toUpperCase().compareTo("LIGHTGRAY")==0) return java.awt.Color.lightGray;
        if (c.toUpperCase().compareTo("MAGENTA")==0) return java.awt.Color.magenta;
        if (c.toUpperCase().compareTo("ORANGE")==0) return java.awt.Color.orange;
        if (c.toUpperCase().compareTo("PINK")==0) return java.awt.Color.pink;
        if (c.toUpperCase().compareTo("WHITE")==0) return java.awt.Color.white;
        if (c.toUpperCase().compareTo("YELLOW")==0) return java.awt.Color.yellow;
        try 
        {
            return java.awt.Color.decode(c);
        } 
        catch (Exception e) 
        {
            return java.awt.Color.black;
        }
    }

  // convert an applet parameter to a Font
  public java.awt.Font convertFont(String f) {

    String[] items=convertList(f);

   if (items==null) return null;

    if (items.length<3) return null;

    int s=java.awt.Font.PLAIN;
    if (items[1].compareTo("BOLD")==0) s=java.awt.Font.BOLD;
    if (items[1].compareTo("ITALIC")==0) s=java.awt.Font.ITALIC;

    try {
    return new java.awt.Font(items[0],s,new Integer(items[2]).intValue());
    }
    catch (Exception e) {return null;}

  }

  // ** updated for servlet operation 5/31/2001
  // get a parameter as string
  protected String getStringParam(String Param,String def) {

      return this.getParameter(Param, def);


    }


  //Get a parameter value
  private String getParameter(String key, String def) {


    if (isStandalone) return def;

    if (this.getParameter(key) != null) return this.getParameter(key) ;
    else return def;
  }

  private String[] convertList(String items){

   String[] itema=new String[500];
   int itemCount=0;

   // count number of items
   int p=items.indexOf("|");
   while (p>=0) {
      itema[itemCount++]=items.substring(0,p);
      items=items.substring(p+1,items.length());
      p=items.indexOf("|");
   }

   if (items.compareTo("")!=0) itema[itemCount++]=items;

   if (itemCount==0) return null;

   String[] result=new String[itemCount];
   for (int i=0;i<itemCount;i++) result[i]=itema[i];

   return result;

 }

  private Integer getIntParam(String Param,Integer def) {

    try {
      String s=this.getParameter(Param ,"");
      if (s.compareTo("")==0) return def;
      return new Integer(s);
    }
    catch(Exception e) {
      return def;
    }
   }

   private Double getDoubleParam(String Param,Double def) {

      try {
       String s=this.getParameter(Param ,"");
      if (s.compareTo("")==0) return def;
     return new Double(s);
    }
    catch(Exception e) {
      return def;
    }
    }
    // ** end of update

}
